LDEXP(3)

NAME
ldexp, ldexpf, ldexpl - multiply floating-point number by integral power of 2

SYNOPSIS
#include <math.h>

double ldexp(double x, int exp);
float ldexpf(float x, int exp);
long double ldexpl(long double x, int exp);

Link with -lm.

Feature Test Macro Requirements for glibc (see feature_test_macros(7)):

ldexpf(), ldexpl(): _BSD_SOURCE || _SVID_SOURCE || _XOPEN_SOURCE >= 600 || _ISOC99_SOURCE; or cc -std=c99

DESCRIPTION
The ldexp() function returns the result of multiplying the floating-point number x by 2 raised to the power exp.

RETURN VALUE
On success, these functions return x * (2^exp). If exp is zero, then x is returned. If x is a NaN, a NaN is returned. If x is positive infinity (negative infinity), positive infinity (negative infinity) is returned. If the result underflows, an range error occurs, and zero is returned. If the result overflows, a range error occurs, and the functions return HUGE_VAL, HUGE_VALF, or HUGE_VALL, respectively, with a sign the same as x.

ERRORS
See math_error(7) for information on how to determine whether an error has occurred when calling these functions.

The following errors can occur:

Range error, overflow
    errno is set to ERANGE. An overflow floating-point exception (FE_OVERFLOW) is raised.

Range error, underflow
    errno is set to ERANGE. An underflow floating-point exception (FE_UNDERFLOW) is raised.

CONFORMING TO
C99, POSIX.1-2001. The variant returning double also conforms to SVr4, 4.3BSD, C89.

SEE ALSO
frexp(3), modf(3), scalbln(3)

COLOPHON
This page is part of release 3.24 of the Linux man-pages project. A description of the project, and information about reporting bugs, can be found at http://www.kernel.org/doc/man-pages/.